diff --git a/util/nbt/src/test/java/TestCompoundTag.java b/util/nbt/src/test/java/TestCompoundTag.java
new file mode 100644
index 000000000..f8649b196
--- /dev/null
+++ b/util/nbt/src/test/java/TestCompoundTag.java
@@ -0,0 +1,116 @@
+import com.mojang.nbt.tags.CompoundTag;
+import com.mojang.nbt.tags.IntTag;
+import com.mojang.nbt.tags.ListTag;
+import org.junit.jupiter.api.Assertions;
+import org.junit.jupiter.api.Test;
+
+public class TestCompoundTag {
+    @Test
+    public void testTag() {
+        CompoundTag compoundTagEmpty1 = new CompoundTag();
+        CompoundTag compoundTagEmpty2 = new CompoundTag();
+        Assertions.assertNotNull(compoundTagEmpty1.getValue(), "Empty compound tag should be non null!");
+        Assertions.assertTrue(compoundTagEmpty1.getValue().isEmpty(), "Empty compound tag should be empty!");
+        Assertions.assertEquals(compoundTagEmpty1.getId(), 10, "Tag id does not match its expected id!");
+        Assertions.assertEquals(compoundTagEmpty1, compoundTagEmpty2, "Empty tags should pass equality check!");
+
+        Assertions.assertEquals(false, compoundTagEmpty1.getBoolean("bool"), "Compound tag getBoolean does not equal expected default!");
+        Assertions.assertEquals(0, compoundTagEmpty1.getByte("byte"), "Compound tag getByte does not equal expected default!");
+        Assertions.assertArrayEquals(new byte[0], compoundTagEmpty1.getByteArray("byteArray"), "Compound tag getByteArray does not equal expected default!");
+        Assertions.assertEquals(0, compoundTagEmpty1.getShort("short"), "Compound tag getShort does not equal expected default!");
+        Assertions.assertArrayEquals(new short[0], compoundTagEmpty1.getShortArray("shortArray"), "Compound tag getShortArray does not equal expected default!");
+        Assertions.assertEquals(0, compoundTagEmpty1.getInteger("int"), "Compound tag getInteger does not equal expected default!");
+//        Assertions.assertArrayEquals(new short[0], compoundTagEmpty1.getIntegerArray("intArray"), "Compound tag getIntegerArray does not equal expected default!");
+        Assertions.assertEquals(0, compoundTagEmpty1.getFloat("float"), "Compound tag getFloat does not equal expected default!");
+//        Assertions.assertArrayEquals(new float[0], compoundTagEmpty1.getFloatArray("floatArray"), "Compound tag getFloatArray does not equal expected default!");
+        Assertions.assertEquals(0, compoundTagEmpty1.getLong("long"), "Compound tag getLong does not equal expected default!");
+        Assertions.assertArrayEquals(new long[0], compoundTagEmpty1.getLongArray("longArray"), "Compound tag getLongArray does not equal expected default!");
+        Assertions.assertEquals(0, compoundTagEmpty1.getDouble("double"), "Compound tag getDouble does not equal expected default!");
+        Assertions.assertArrayEquals(new double[0], compoundTagEmpty1.getDoubleArray("doubleArray"), "Compound tag getDoubleArray does not equal expected default!");
+        Assertions.assertEquals("", compoundTagEmpty1.getString("string"), "Compound tag getString does not equal expected default!");
+        Assertions.assertEquals(new ListTag(), compoundTagEmpty1.getList("list"), "Compound tag getList does not equal expected default!");
+        Assertions.assertEquals(new CompoundTag(), compoundTagEmpty1.getCompound("compound"), "Compound tag getCompound does not equal expected default!");
+
+        boolean defBool = true;
+        byte defByte = Byte.MAX_VALUE;
+        byte[] defByteArray = new byte[]{Byte.MIN_VALUE, 0, Byte.MAX_VALUE};
+        short defShort = Short.MAX_VALUE;
+        short[] defShortArray = new short[]{Short.MIN_VALUE, 0, Short.MAX_VALUE};
+        int defInt = Integer.MAX_VALUE;
+        int[] defIntArray = new int[]{Integer.MIN_VALUE, 0, Integer.MAX_VALUE};
+        float defFloat = Float.MAX_VALUE;
+        float[] defFloatArray = new float[]{Float.NEGATIVE_INFINITY, Float.MIN_VALUE, Float.NaN, 0, Float.MAX_VALUE, Float.POSITIVE_INFINITY};
+        long defLong = Long.MAX_VALUE;
+        long[] defLongArray = new long[]{Long.MIN_VALUE, 0, Long.MAX_VALUE};
+        double defDouble = Double.MAX_VALUE;
+        double[] defDoubleArray = new double[]{Double.NEGATIVE_INFINITY, Double.MIN_VALUE, Double.NaN, 0, Double.MAX_VALUE, Double.POSITIVE_INFINITY};
+        String defString = "default";
+        ListTag defList = new ListTag(); defList.addTag(new IntTag(0)); defList.addTag(new IntTag(1)); defList.addTag(new IntTag(2));
+        CompoundTag defCompound = new CompoundTag(); defCompound.putInt("0", 0); defCompound.putLong("0", 0);
+
+        Assertions.assertEquals(defBool, compoundTagEmpty1.getBooleanOrDefault("bool", defBool), "Compound tag getBooleanOrDefault does not equal expected default!");
+        Assertions.assertEquals(defByte, compoundTagEmpty1.getByteOrDefault("byte", defByte), "Compound tag getByteOrDefault does not equal expected default!");
+        Assertions.assertArrayEquals(defByteArray, compoundTagEmpty1.getByteArrayOrDefault("byteArray", defByteArray), "Compound tag getByteArrayOrDefault does not equal expected default!");
+        Assertions.assertEquals(defShort, compoundTagEmpty1.getShortOrDefault("short", defShort), "Compound tag getShortOrDefault does not equal expected default!");
+        Assertions.assertArrayEquals(defShortArray, compoundTagEmpty1.getShortArrayOrDefault("shortArray", defShortArray), "Compound tag getShortArrayOrDefault does not equal expected default!");
+        Assertions.assertEquals(defInt, compoundTagEmpty1.getIntegerOrDefault("int", defInt), "Compound tag getIntegerOrDefault does not equal expected default!");
+//        Assertions.assertArrayEquals(defShortArray, compoundTagEmpty1.getIntegerArrayOrDefault("intArray", defShortArray), "Compound tag getIntegerArrayOrDefault does not equal expected default!");
+        Assertions.assertEquals(defFloat, compoundTagEmpty1.getFloatOrDefault("float", defFloat), "Compound tag getFloatOrDefault does not equal expected default!");
+//        Assertions.assertArrayEquals(defFloatArray, compoundTagEmpty1.getFloatArrayOrDefault("floatArray", defFloatArray), "Compound tag getFloatArrayOrDefault does not equal expected default!");
+        Assertions.assertEquals(defLong, compoundTagEmpty1.getLongOrDefault("long", defLong), "Compound tag getLongOrDefault does not equal expected default!");
+        Assertions.assertArrayEquals(defLongArray, compoundTagEmpty1.getLongArrayOrDefault("longArray", defLongArray), "Compound tag getLongArrayOrDefault does not equal expected default!");
+        Assertions.assertEquals(defDouble, compoundTagEmpty1.getDoubleOrDefault("double", defDouble), "Compound tag getDoubleOrDefault does not equal expected default!");
+        Assertions.assertArrayEquals(defDoubleArray, compoundTagEmpty1.getDoubleArrayOrDefault("doubleArray", defDoubleArray), "Compound tag getDoubleArrayOrDefault does not equal expected default!");
+        Assertions.assertEquals(defString, compoundTagEmpty1.getStringOrDefault("string", defString), "Compound tag getStringOrDefault does not equal expected default!");
+        Assertions.assertEquals(defList, compoundTagEmpty1.getListOrDefault("list", defList), "Compound tag getListOrDefault does not equal expected default!");
+        Assertions.assertEquals(defCompound, compoundTagEmpty1.getCompoundOrDefault("compound", defCompound), "Compound tag getCompoundOrDefault does not equal expected default!");
+
+        CompoundTag basicCompoundTag = new CompoundTag();
+        basicCompoundTag.putString("String", "Hello World!");
+        basicCompoundTag.putInt("Int", 7695);
+        basicCompoundTag.putByteArray("ByteArray", new byte[]{Byte.MIN_VALUE, 0, Byte.MAX_VALUE});
+
+        Assertions.assertEquals(3, basicCompoundTag.getValue().size(), "Compound tag size does not match the expected number of entries");
+        Assertions.assertEquals("Hello World!", basicCompoundTag.getString("String"));
+        Assertions.assertEquals(7695, basicCompoundTag.getInteger("Int"));
+        Assertions.assertArrayEquals(new byte[]{Byte.MIN_VALUE, 0, Byte.MAX_VALUE}, basicCompoundTag.getByteArray("ByteArray"));
+
+        CompoundTag allTags = new CompoundTag();
+
+        allTags.putBoolean("bool", defBool);
+        allTags.putByte("byte", defByte);
+        allTags.putByteArray("byteArray", defByteArray);
+        allTags.putShort("short", defShort);
+        allTags.putShortArray("shortArray", defShortArray);
+        allTags.putInt("int", defInt);
+//        allTags.putIntegerArray("intArray", defIntArray);
+        allTags.putFloat("float", defFloat);
+//        allTags.putFloatArray("floatArray", defFloatArray);
+        allTags.putLong("long", defLong);
+        allTags.putLongArray("longArray", defLongArray);
+        allTags.putDouble("double", defDouble);
+        allTags.putDoubleArray("doubleArray", defDoubleArray);
+        allTags.putString("string", defString);
+        allTags.putList("list", defList);
+        allTags.putCompound("compound", defCompound);
+
+        Assertions.assertEquals(defBool, allTags.getBoolean("bool"), "Compound tag getBoolean does not equal expected default!");
+        Assertions.assertEquals(defByte, allTags.getByte("byte"), "Compound tag getByte does not equal expected default!");
+        Assertions.assertArrayEquals(defByteArray, allTags.getByteArray("byteArray"), "Compound tag getByteArray does not equal expected default!");
+        Assertions.assertEquals(defShort, allTags.getShort("short"), "Compound tag getShort does not equal expected default!");
+        Assertions.assertArrayEquals(defShortArray, allTags.getShortArray("shortArray"), "Compound tag getShortArray does not equal expected default!");
+        Assertions.assertEquals(defInt, allTags.getInteger("int"), "Compound tag getInteger does not equal expected default!");
+//        Assertions.assertArrayEquals(defIntArray, allTags.getIntegerArray("intArray"), "Compound tag getIntegerArray does not equal expected default!");
+        Assertions.assertEquals(defFloat, allTags.getFloat("float"), "Compound tag getFloat does not equal expected default!");
+//        Assertions.assertArrayEquals(defFloatArray, allTags.getFloatArray("floatArray"), "Compound tag getFloatArray does not equal expected default!");
+        Assertions.assertEquals(defLong, allTags.getLong("long"), "Compound tag getLong does not equal expected default!");
+        Assertions.assertArrayEquals(defLongArray, allTags.getLongArray("longArray"), "Compound tag getLongArray does not equal expected default!");
+        Assertions.assertEquals(defDouble, allTags.getDouble("double"), "Compound tag getDouble does not equal expected default!");
+        Assertions.assertArrayEquals(defDoubleArray, allTags.getDoubleArray("doubleArray"), "Compound tag getDoubleArray does not equal expected default!");
+        Assertions.assertEquals(defString, allTags.getString("string"), "Compound tag getString does not equal expected default!");
+        Assertions.assertEquals(defList, allTags.getList("list"), "Compound tag getList does not equal expected default!");
+        Assertions.assertEquals(defCompound, allTags.getCompound("compound"), "Compound tag getCompound does not equal expected default!");
+
+        Assertions.assertEquals(allTags, new CompoundTag(allTags), "Compound tag clone does not equal its source!");
+    }
+}
diff --git a/util/nbt/src/test/java/TestDoubleArrayTag.java b/util/nbt/src/test/java/TestDoubleArrayTag.java
new file mode 100644
index 000000000..3ca53d2d6
--- /dev/null
+++ b/util/nbt/src/test/java/TestDoubleArrayTag.java
@@ -0,0 +1,21 @@
+import com.mojang.nbt.tags.DoubleArrayTag;
+import org.junit.jupiter.api.Assertions;
+import org.junit.jupiter.api.Test;
+
+public class TestDoubleArrayTag {
+    @Test
+    public void testTag() {
+        DoubleArrayTag doubleArrayTagEmpty = new DoubleArrayTag();
+        Assertions.assertEquals(doubleArrayTagEmpty.getId(), 12, "Tag id does not match its expected id!");
+        Assertions.assertArrayEquals(new double[0], doubleArrayTagEmpty.getValue(), "Default double array tag value should be and empty array!");
+
+        DoubleArrayTag doubleArrayTag1 = new DoubleArrayTag(new double[]{-1, 0, 2, 7, 9, Double.NEGATIVE_INFINITY, Double.MIN_VALUE, Double.NaN, 0, Double.MAX_VALUE, Double.POSITIVE_INFINITY});
+        Assertions.assertArrayEquals(new double[]{-1, 0, 2, 7, 9, Double.NEGATIVE_INFINITY, Double.MIN_VALUE, Double.NaN, 0, Double.MAX_VALUE, Double.POSITIVE_INFINITY}, doubleArrayTag1.getValue(), "Tag value does not match its equivalent array!");
+
+        DoubleArrayTag doubleArrayTag2 = new DoubleArrayTag(new double[]{-1, 0, 2, 7, 9, Double.NEGATIVE_INFINITY, Double.MIN_VALUE, Double.NaN, 0, Double.MAX_VALUE, Double.POSITIVE_INFINITY});
+        Assertions.assertEquals(doubleArrayTag2, doubleArrayTag1, "Tag value does not equal its equivalent tag!");
+
+        DoubleArrayTag doubleArrayTag3 = new DoubleArrayTag(new double[]{Double.NEGATIVE_INFINITY, Double.MIN_VALUE, Double.NaN, 0, Double.MAX_VALUE, Double.POSITIVE_INFINITY, 9, 7, 2, 0, -1});
+        Assertions.assertNotEquals(doubleArrayTag3, doubleArrayTag2, "Tag equals non equivalent tag!");
+    }
+}
diff --git a/util/nbt/src/test/java/TestDoubleTag.java b/util/nbt/src/test/java/TestDoubleTag.java
new file mode 100644
index 000000000..0085385d9
--- /dev/null
+++ b/util/nbt/src/test/java/TestDoubleTag.java
@@ -0,0 +1,21 @@
+import com.mojang.nbt.tags.DoubleTag;
+import org.junit.jupiter.api.Assertions;
+import org.junit.jupiter.api.Test;
+
+public class TestDoubleTag {
+    @Test
+    public void testTag() {
+        DoubleTag doubleTagEmpty = new DoubleTag();
+        Assertions.assertEquals(doubleTagEmpty.getId(), 6, "Tag id does not match its expected id!");
+        Assertions.assertEquals(doubleTagEmpty.getValue(), 0, "Default double tag value should be 0!");
+
+        DoubleTag doubleTag1 = new DoubleTag(Double.MAX_VALUE);
+        Assertions.assertEquals(Double.MAX_VALUE, doubleTag1.getValue(), "Tag value does not match its equivalent value!");
+
+        DoubleTag doubleTag2 = new DoubleTag(Double.MAX_VALUE);
+        Assertions.assertEquals(doubleTag2, doubleTag1, "Tag value does not equal its equivalent tag!");
+
+        DoubleTag doubleTag3 = new DoubleTag(Double.MIN_VALUE);
+        Assertions.assertNotEquals(doubleTag3, doubleTag2, "Tag equals non equivalent tag!");
+    }
+}
diff --git a/util/nbt/src/test/java/TestFloatTag.java b/util/nbt/src/test/java/TestFloatTag.java
new file mode 100644
index 000000000..79aed0b71
--- /dev/null
+++ b/util/nbt/src/test/java/TestFloatTag.java
@@ -0,0 +1,21 @@
+import com.mojang.nbt.tags.FloatTag;
+import org.junit.jupiter.api.Assertions;
+import org.junit.jupiter.api.Test;
+
+public class TestFloatTag {
+    @Test
+    public void testTag() {
+        FloatTag floatTagEmpty = new FloatTag();
+        Assertions.assertEquals(floatTagEmpty.getId(), 5, "Tag id does not match its expected id!");
+        Assertions.assertEquals(floatTagEmpty.getValue(), 0, "Default float tag value should be 0!");
+
+        FloatTag floatTag1 = new FloatTag(Float.MAX_VALUE);
+        Assertions.assertEquals(Float.MAX_VALUE, floatTag1.getValue(), "Tag value does not match its equivalent value!");
+
+        FloatTag floatTag2 = new FloatTag(Float.MAX_VALUE);
+        Assertions.assertEquals(floatTag2, floatTag1, "Tag value does not equal its equivalent tag!");
+
+        FloatTag floatTag3 = new FloatTag(Float.MIN_VALUE);
+        Assertions.assertNotEquals(floatTag3, floatTag2, "Tag equals non equivalent tag!");
+    }
+}
diff --git a/util/nbt/src/test/java/TestIntTag.java b/util/nbt/src/test/java/TestIntTag.java
new file mode 100644
index 000000000..73442810b
--- /dev/null
+++ b/util/nbt/src/test/java/TestIntTag.java
@@ -0,0 +1,21 @@
+import com.mojang.nbt.tags.IntTag;
+import org.junit.jupiter.api.Assertions;
+import org.junit.jupiter.api.Test;
+
+public class TestIntTag {
+    @Test
+    public void testTag() {
+        IntTag intTagEmpty = new IntTag();
+        Assertions.assertEquals(intTagEmpty.getId(), 3, "Tag id does not match its expected id!");
+        Assertions.assertEquals(intTagEmpty.getValue(), 0, "Default int tag value should be 0!");
+
+        IntTag intTag1 = new IntTag(Integer.MAX_VALUE);
+        Assertions.assertEquals(Integer.MAX_VALUE, intTag1.getValue(), "Tag value does not match its equivalent value!");
+
+        IntTag intTag2 = new IntTag(Integer.MAX_VALUE);
+        Assertions.assertEquals(intTag2, intTag1, "Tag value does not equal its equivalent tag!");
+
+        IntTag intTag3 = new IntTag(Integer.MIN_VALUE);
+        Assertions.assertNotEquals(intTag3, intTag2, "Tag equals non equivalent tag!");
+    }
+}
diff --git a/util/nbt/src/test/java/TestListTag.java b/util/nbt/src/test/java/TestListTag.java
new file mode 100644
index 000000000..0dae08faf
--- /dev/null
+++ b/util/nbt/src/test/java/TestListTag.java
@@ -0,0 +1,41 @@
+import com.mojang.nbt.tags.IntTag;
+import com.mojang.nbt.tags.ListTag;
+import org.junit.jupiter.api.Assertions;
+import org.junit.jupiter.api.Test;
+
+public class TestListTag {
+    @Test
+    public void testTag() {
+        ListTag listTagEmpty = new ListTag();
+        Assertions.assertEquals(listTagEmpty.getId(), 9, "Tag id does not match its expected id!");
+        Assertions.assertNotNull(listTagEmpty.getValue(), "Default list tag should not be null!");
+        Assertions.assertTrue(listTagEmpty.getValue().isEmpty(), "Default list tag should be empty!");
+
+        ListTag intTags1 = new ListTag();
+        intTags1.addTag(new IntTag(0));
+        intTags1.addTag(new IntTag(1));
+        intTags1.addTag(new IntTag(2));
+        intTags1.addTag(new IntTag(3));
+        intTags1.addTag(new IntTag(4));
+
+        Assertions.assertEquals(5, intTags1.getValue().size(), "List tag size does not match expected value!");
+
+        ListTag intTags2 = new ListTag();
+        intTags2.addTag(new IntTag(0));
+        intTags2.addTag(new IntTag(1));
+        intTags2.addTag(new IntTag(2));
+        intTags2.addTag(new IntTag(3));
+        intTags2.addTag(new IntTag(4));
+
+        Assertions.assertEquals(intTags1, intTags2, "List tag does not equal equivalent list!");
+
+        ListTag intTags3 = new ListTag();
+        intTags3.addTag(new IntTag(4));
+        intTags3.addTag(new IntTag(3));
+        intTags3.addTag(new IntTag(2));
+        intTags3.addTag(new IntTag(1));
+        intTags3.addTag(new IntTag(0));
+
+        Assertions.assertNotEquals(intTags2, intTags3, "List tag equals a non equivalent list!");
+    }
+}
diff --git a/util/nbt/src/test/java/TestLongArrayTag.java b/util/nbt/src/test/java/TestLongArrayTag.java
new file mode 100644
index 000000000..671c0c543
--- /dev/null
+++ b/util/nbt/src/test/java/TestLongArrayTag.java
@@ -0,0 +1,21 @@
+import com.mojang.nbt.tags.LongArrayTag;
+import org.junit.jupiter.api.Assertions;
+import org.junit.jupiter.api.Test;
+
+public class TestLongArrayTag {
+    @Test
+    public void testTag() {
+        LongArrayTag longArrayTagEmpty = new LongArrayTag();
+        Assertions.assertEquals(longArrayTagEmpty.getId(), 13, "Tag id does not match its expected id!");
+        Assertions.assertArrayEquals(new long[0], longArrayTagEmpty.getValue(), "Default long array tag value should be and empty array!");
+
+        LongArrayTag longArrayTag1 = new LongArrayTag(new long[]{-1, 0, 2, 7, 9, Long.MIN_VALUE, 0, Long.MAX_VALUE});
+        Assertions.assertArrayEquals(new long[]{-1, 0, 2, 7, 9, Long.MIN_VALUE, 0, Long.MAX_VALUE}, longArrayTag1.getValue(), "Tag value does not match its equivalent array!");
+
+        LongArrayTag longArrayTag2 = new LongArrayTag(new long[]{-1, 0, 2, 7, 9, Long.MIN_VALUE, 0, Long.MAX_VALUE});
+        Assertions.assertEquals(longArrayTag2, longArrayTag1, "Tag value does not equal its equivalent tag!");
+
+        LongArrayTag longArrayTag3 = new LongArrayTag(new long[]{Long.MIN_VALUE, 0, Long.MAX_VALUE, 9, 7, 2, 0, -1});
+        Assertions.assertNotEquals(longArrayTag3, longArrayTag2, "Tag equals non equivalent tag!");
+    }
+}
diff --git a/util/nbt/src/test/java/TestLongTag.java b/util/nbt/src/test/java/TestLongTag.java
new file mode 100644
index 000000000..3832ee0bf
--- /dev/null
+++ b/util/nbt/src/test/java/TestLongTag.java
@@ -0,0 +1,21 @@
+import com.mojang.nbt.tags.LongTag;
+import org.junit.jupiter.api.Assertions;
+import org.junit.jupiter.api.Test;
+
+public class TestLongTag {
+    @Test
+    public void testTag() {
+        LongTag longTagEmpty = new LongTag();
+        Assertions.assertEquals(longTagEmpty.getId(), 4, "Tag id does not match its expected id!");
+        Assertions.assertEquals(longTagEmpty.getValue(), 0, "Default long tag value should be 0!");
+
+        LongTag longTag1 = new LongTag(Long.MAX_VALUE);
+        Assertions.assertEquals(Long.MAX_VALUE, longTag1.getValue(), "Tag value does not match its equivalent value!");
+
+        LongTag longTag2 = new LongTag(Long.MAX_VALUE);
+        Assertions.assertEquals(longTag2, longTag1, "Tag value does not equal its equivalent tag!");
+
+        LongTag longTag3 = new LongTag(Long.MIN_VALUE);
+        Assertions.assertNotEquals(longTag3, longTag2, "Tag equals non equivalent tag!");
+    }
+}
